Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 618170 - dev-lisp/clisp misbehaves with pie-enabled gcc unless compiled with -no-pie
Summary: dev-lisp/clisp misbehaves with pie-enabled gcc unless compiled with -no-pie
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Common Lisp Bugs
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: gcc-6 582688 gcc-6-stable
  Show dependency tree
 
Reported: 2017-05-11 07:02 UTC by Martin Väth
Modified: 2017-10-25 14:36 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Failed build.log of fricas when clisp is compiled without -no-pie (sci-mathematics:fricas-1.3.2:20170511-065100.log,24.40 KB, text/x-log)
2017-05-11 07:02 UTC, Martin Väth
Details
emerge --info of x86 system (emerge-info,16.43 KB, text/plain)
2017-05-11 07:22 UTC, Martin Väth
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Väth 2017-05-11 07:02:53 UTC
Created attachment 472310 [details]
Failed build.log of fricas when clisp is compiled without -no-pie

I tested with dev-lisp/clisp-2.49-r100 and sys-devel/gcc-7.1.0-r1[pie], although I guess that the same problem will occur with earlier versions as well.

Although emerge of clisp works perfectly, a subsequent emerge of sci-mathematics/fricas-1.3.2[clisp] fails with the strange error message:
module 'syscalls' requires package OS
(Failed build log is attached).

After adding -no-pie to the CFLAGS (when emerging clisp), the subsequent emerge of fricas succeeds.

Since the latest version of clisp is from 2010, I suppose that reporting the issue to upstream is pointless, and the ebuild should just add -no-pie.
Comment 1 Martin Väth 2017-05-11 07:22:30 UTC
Created attachment 472312 [details]
emerge --info of x86 system

The attached emerge --info is from an x86 system,
but the same issue occurs with an amd64 system
(which has a very similar emerge --info, e.g. with identical package versions)
Comment 2 Andreas K. Hüttel gentoo-dev 2017-10-21 14:33:04 UTC
Ping - this blocks gcc-6 stabilization.
Comment 3 Chema Alonso Josa (RETIRED) gentoo-dev 2017-10-21 20:50:25 UTC
Last version of CLISP was released 7 years ago. I guess nobody is working on the multiple bugs of this package:

https://bugs.gentoo.org/buglist.cgi?quicksearch=clisp
Comment 4 Larry the Git Cow gentoo-dev 2017-10-24 18:47:14 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=903dbc323ec045290c9a9a5809bde6ce8e2f8938

commit 903dbc323ec045290c9a9a5809bde6ce8e2f8938
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2017-10-24 18:46:31 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2017-10-24 18:47:04 +0000

    dev-lisp/clisp: Add revision bumps forcing -no-pie, bug 594552
    
    Both stable (straight to stable) subslot (for stable readline) and
    ~arch subslot (for ~arch readline) are handled.
    
    Closes: https://bugs.gentoo.org/618170
    Package-Manager: Portage-2.3.12, Repoman-2.3.3

 dev-lisp/clisp/clisp-2.49-r101.ebuild | 153 ++++++++++++++++++++++++++++++++++
 dev-lisp/clisp/clisp-2.49-r9.ebuild   | 147 ++++++++++++++++++++++++++++++++
 2 files changed, 300 insertions(+)
Comment 5 Rafal Lalik 2017-10-25 09:35:43 UTC
With the -no-pie flag my ebuild fails at configure level. With my gcc

$ gcc -v
Using built-in specs.
COLLECT_GCC=gcc
COLLECT_LTO_WRAPPER=/usr/libexec/gcc/x86_64-pc-linux-gnu/5.4.0/lto-wrapper
Target: x86_64-pc-linux-gnu
Configured with: /var/tmp/portage/sys-devel/gcc-5.4.0-r3/work/gcc-5.4.0/configure --host=x86_64-pc-linux-gnu --build=x86_64-pc-linux-gnu --prefix=/usr --bindir=/usr/x86_64-pc-linux-gnu/gcc-bin/5.4.0 --includedir=/usr/lib/gcc/x86_64-pc-linux-gnu/5.4.0/include --datadir=/usr/share/gcc-data/x86_64-pc-linux-gnu/5.4.0 --mandir=/usr/share/gcc-data/x86_64-pc-linux-gnu/5.4.0/man --infodir=/usr/share/gcc-data/x86_64-pc-linux-gnu/5.4.0/info --with-gxx-include-dir=/usr/lib/gcc/x86_64-pc-linux-gnu/5.4.0/include/g++-v5 --with-python-dir=/share/gcc-data/x86_64-pc-linux-gnu/5.4.0/python --enable-languages=c,c++,java,fortran --enable-obsolete --enable-secureplt --disable-werror --with-system-zlib --enable-nls --without-included-gettext --enable-checking=release --with-bugurl=https://bugs.gentoo.org/ --with-pkgversion='Gentoo 5.4.0-r3 p1.4, pie-0.6.5' --enable-libstdcxx-time --enable-shared --enable-threads=posix --enable-__cxa_atexit --enable-clocale=gnu --enable-multilib --with-multilib-list=m32,m64 --disable-altivec --disable-fixed-point --enable-targets=all --enable-libgomp --disable-libmudflap --disable-libssp --disable-libcilkrts --disable-libmpx --enable-vtable-verify --enable-libvtv --enable-lto --without-isl --enable-libsanitizer
Thread model: posix
gcc version 5.4.0 (Gentoo 5.4.0-r3 p1.4, pie-0.6.5)

I have following:

$ gcc -no-pie
gcc: error: unrecognized command line option ‘-no-pie’
gcc: fatal error: no input files


but

$ gcc -fno-pie
gcc: fatal error: no input files

So I chabged -no-pie -t -no-fpie and it worked.
Comment 6 Nicolas Bock gentoo-dev 2017-10-25 14:28:40 UTC
I can confirm that it needs -fno-pie for gcc:5.4.0.
Comment 7 Nicolas Bock gentoo-dev 2017-10-25 14:36:16 UTC
Sorry, just update my tree and realized that 3372a5ecbeaa719f733cccf67caf8f96b61f3d2c fixes it.